{$Align OFF} // IMPORTANT !!!!
{$H+}
uses windows,sysutils,collection,tems;

Type
     PByte      = ^Byte;
     PGDEntry   = ^TGDEntry;
     TGDEntry   = Record
                     Status : Byte;
                     UnitNo : Word;
                     Offset : Word;
                     FLen   : Word;
                     Chk    : Word;
                  End;
     pgdfs_store_entry=^tgdfs_store_entry;
     tgdfs_store_entry=record
        gd_var:tgdentry;
        gd_body:pbytearray;
        block_num:byte;
        end;


     pgdfs_store=^tgdfs_store;
     tgdfs_store= class(tsortedcollection)
                function Compare(Key1, Key2: Pointer): Integer; override;
                procedure FreeItem(Item:pointer); override;
                function get_var(num:word):pgdfs_store_entry;
                procedure dump(num:word);
        end;

function tgdfs_store.Compare(Key1, Key2: Pointer): Integer;

begin
result:=0;
if pgdfs_store_entry(key1)^.gd_var.unitno<pgdfs_store_entry(key2)^.gd_var.unitno
        then result:=-1;
if pgdfs_store_entry(key1)^.gd_var.unitno>pgdfs_store_entry(key2)^.gd_var.unitno
        then result:=1;
end;

function tgdfs_store.get_var(num:word):pgdfs_store_entry;
var
s_entry:tgdfs_store_entry;
idx:integer;
begin
result:=nil;
fillchar(s_entry,sizeof(s_entry),0);
s_entry.gd_var.unitno:=num;
if search(@s_entry,idx) then
        result:=at(idx);
end;

procedure tgdfs_store.dump(num:word);

var
chk:word;
i:integer;
gd:pgdentry;
pent:pgdfs_store_entry;

begin
        pent:=get_var(num);
        gd:=@pent^.gd_var;
        write(inttohex(pent^.block_num,4),' ',inttohex(gd^.unitno,4),' ',
                inttohex(gd^.flen,4),' ');
                writeln;
        chk:=0;
        for i:=1 to gd^.flen do
                begin
                chk:=(chk+pent^.gd_body^[i]) mod 65536;
                write('0x',inttohex(pent^.gd_body^[i],2),',');
                if (i mod 20)=0 then writeln;
                end;
        writeln;
{        writeln('-b-');
        for i:=1 to gd^.flen do
                begin
                write(chr(pent^.gd_body^[i]));
                if (i mod 60)=0 then writeln;
                end;
        writeln;}
        writeln('-e-,checksum is ',chk=gd^.chk);
end;


procedure tgdfs_store.FreeItem(Item:pointer);
begin
freemem(pgdfs_store_entry(item)^.gd_body,pgdfs_store_entry(item)^.gd_var.flen);
dispose(pgdfs_store_entry(item));
end;

var
f:file;
p:pbytearray;
chk:word;
i,cnt,cnt1,blknum:integer;
gd:pgdentry;
gdfs:tgdfs_store;
pent:pgdfs_store_entry;
fout:text;

begin
//gdfs:=new(pgdfs_store,init (1000,1000));
gdfs:=tGdfs_Store.Create(1000,1000);
        try
        assign(f,paramstr(1));
        reset(f,1);
        except
        writeln(format('invoke me as %s gdfs.bin',[paramstr(0)]));
        exit;
        end;

getmem(p,$10000);
try
        while not eof(f) do
        begin
        blockread(f,p^,$10000);
	blknum:=p^[1];
        //move to first record
        cnt:=9;
        while (pGDentry(dword(p)+$10000-cnt)^.status<>$FF) do
                begin
                gd:=pGDentry(dword(p)+$10000-cnt);
                if gd^.status=$3f then
                        begin
                        pent:=new(pgdfs_store_entry);
                        pent^.block_num:=blknum;
                        move(gd^,pent^.gd_var,sizeof(tgdentry));
                        getmem(pent^.gd_body,gd^.flen+1);
                        move(pbytearray(p)^[gd^.offset],pent^.gd_body^[1],gd^.flen);
                        gdfs.insert(pent);
                        end;
                inc(cnt,9); //end status
                end; //while
//        inc(blknum);
        end; //eof

freemem(p,$10000);
close(f);
except
close(f);
writeln('Error while working with file');
exit;
end;

// dump found units

if gdfs.get_var($1b)<>nil then
        gdfs.dump($1b);
if gdfs.get_var($276)<>nil then
        gdfs.dump($276);
writeln;
writeln('T610 TEMS');
writeln;

try
assign(fout,'t610.gdf');
rewrite(fout);
if ( (gdfs.get_var($1b)<>nil) and (gdfs.get_var($276)<>nil)) then
        begin
        writeln('GDFS_NoBloksErase');
        writeln(fout,'GDFS_NoBloksErase');
        writeln(format('000003B30000%s',[Calc_Tems(pointer(dword(gdfs.get_var($1b)^.gd_body)+1),
                        pointer(dword(gdfs.get_var($276)^.gd_body)+1))]));
        writeln(fout,format('000003B30000%s',[Calc_Tems(pointer(dword(gdfs.get_var($1b)^.gd_body)+1),
                        pointer(dword(gdfs.get_var($276)^.gd_body)+1))]));
        write('000003B50000');
        write(fout,'000003B50000');
        for i:=low(inv4t610) to high(inv4t610) do
                begin
                write(inttohex(inv4t610[i],2));
                write(fout,inttohex(inv4t610[i],2));
                end;
        writeln;
        writeln(fout);
        end;
except
close(fout);
end;
close(fout);

writeln('T68 TEMS');
writeln;
try
assign(fout,'t68i.gdf');
rewrite(fout);
if ( (gdfs.get_var($1b)<>nil) and (gdfs.get_var($276)<>nil)) then
        begin
        writeln('GDFS_NoBloksErase');
        writeln(fout,'GDFS_NoBloksErase');
        writeln(format('000513860000%s',[Calc_Tems_t68(pointer(dword(gdfs.get_var($1b)^.gd_body)+1),
                        pointer(dword(gdfs.get_var($276)^.gd_body)+1))]));
        writeln(fout,format('000513860000%s',[Calc_Tems_t68(pointer(dword(gdfs.get_var($1b)^.gd_body)+1),
                        pointer(dword(gdfs.get_var($276)^.gd_body)+1))]));
        write('000513880000');
        write(fout,'000513880000');
        for i:=low(inv4t68) to high(inv4t68) do
                begin
                write(inttohex(inv4t68[i],2));
                write(fout,inttohex(inv4t68[i],2));
                end;
        writeln;
        writeln(fout);
        end;
except
close(fout);
end;
close(fout);

gdfs.destroy;
end.
